/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// TaskCreationOptions the model 'TaskCreationOptions'
type TaskCreationOptions string

// List of TaskCreationOptions
const (
	TASKCREATIONOPTIONS_NONE                             TaskCreationOptions = "None"
	TASKCREATIONOPTIONS_PREFER_FAIRNESS                  TaskCreationOptions = "PreferFairness"
	TASKCREATIONOPTIONS_LONG_RUNNING                     TaskCreationOptions = "LongRunning"
	TASKCREATIONOPTIONS_ATTACHED_TO_PARENT               TaskCreationOptions = "AttachedToParent"
	TASKCREATIONOPTIONS_DENY_CHILD_ATTACH                TaskCreationOptions = "DenyChildAttach"
	TASKCREATIONOPTIONS_HIDE_SCHEDULER                   TaskCreationOptions = "HideScheduler"
	TASKCREATIONOPTIONS_RUN_CONTINUATIONS_ASYNCHRONOUSLY TaskCreationOptions = "RunContinuationsAsynchronously"
)

// All allowed values of TaskCreationOptions enum
var AllowedTaskCreationOptionsEnumValues = []TaskCreationOptions{
	"None",
	"PreferFairness",
	"LongRunning",
	"AttachedToParent",
	"DenyChildAttach",
	"HideScheduler",
	"RunContinuationsAsynchronously",
}

func (v *TaskCreationOptions) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := TaskCreationOptions(value)
	for _, existing := range AllowedTaskCreationOptionsEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid TaskCreationOptions", value)
}

// NewTaskCreationOptionsFromValue returns a pointer to a valid TaskCreationOptions
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewTaskCreationOptionsFromValue(v string) (*TaskCreationOptions, error) {
	ev := TaskCreationOptions(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for TaskCreationOptions: valid values are %v", v, AllowedTaskCreationOptionsEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v TaskCreationOptions) IsValid() bool {
	for _, existing := range AllowedTaskCreationOptionsEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to TaskCreationOptions value
func (v TaskCreationOptions) Ptr() *TaskCreationOptions {
	return &v
}

type NullableTaskCreationOptions struct {
	value *TaskCreationOptions
	isSet bool
}

func (v NullableTaskCreationOptions) Get() *TaskCreationOptions {
	return v.value
}

func (v *NullableTaskCreationOptions) Set(val *TaskCreationOptions) {
	v.value = val
	v.isSet = true
}

func (v NullableTaskCreationOptions) IsSet() bool {
	return v.isSet
}

func (v *NullableTaskCreationOptions) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTaskCreationOptions(val *TaskCreationOptions) *NullableTaskCreationOptions {
	return &NullableTaskCreationOptions{value: val, isSet: true}
}

func (v NullableTaskCreationOptions) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTaskCreationOptions) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
